class TListItems:
    def __init__(self, owner):
        self.item = []
        self.count = 0
        self.owner = owner

    def append(self, item):
        self.item.append(item)
        self.count = self.count + 1
        if self._update:
            self.owner.redraw()
        return self.count - 1

    def remove(self, index):
        try:
            del self.item[index]
            self.count = self.count - 1
        except:
            pass
        if self._update:
            self.owner.redraw()
        return

    def indexOf(self, item):
        return self.item.index(item)

    def beginUpdate(self):
        self._update = 0

    def endUpdate(self):
        self._update = 1
        self.owner.redraw()

    def __len__(self):
        return len(self.item)

    def __getitem__(self, index):
        return self.item[index]

    def __delitem__(self, index):
        self.remove(index)

class TListItem:
    def __init__(self):
        self.subitems = []
        self.caption = ''
        self.data = None
