import FtServerResources__POA, FtServerResources

from Ft.Server.Protocols.CORBA.FtOmniorb import OoContainerImp
from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import CorbaUtil, ExceptionUtil, DocDefCorbaHelper



class SystemDocDefContainerImp(FtServerResources__POA.SystemDocDefContainerIf,OoContainerImp.ContainerImp):


    def hasDocumentDefinition(self,name):
        return self._runSafe(self.resource.hasDocumentDefinition,(name,))


    def createDocumentDefinition(self,name,nss,rdfMaps,cp):
        nss = DocDefCorbaHelper.NssMapsFromCorba(nss)
        rdfMaps = DocDefCorbaHelper.RdfMapFromCorba(rdfMaps)
        cp = DocDefCorbaHelper.CreationParamsFromCorba(cp)
        return self._runSafe(self.resource.createDocumentDefinition,(name,nss,rdfMaps,cp),self._mapResource)

    def deleteDocumentDefinition(self,name):
        return self._runSafe(self.resource.deleteDocumentDefinition,(name,))

    def fetchDocumentDefinition(self,name):
        return self._runSafe(self.resource.fetchDocumentDefinition,(name,),self._mapResource)

        
