import FtServerResources__POA, FtServerResources

from Ft.Server.Protocols.CORBA.FtOmniorb import OoContainerImp
from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import CorbaUtil, ExceptionUtil



class SystemUserContainerImp(FtServerResources__POA.SystemUserContainerIf,OoContainerImp.ContainerImp):
    def hasUser(self,userName):
        return self._runSafe(self.resource.hasUser,(userName,))

    def createUser(self,userName,passwordHash):
        return self._runSafe(self.resource.createUser,(userName,passwordHash),self._mapResource)

